Python3 与 C# 面向对象之~十分相关

周末多码文,明日上午一篇,后天再来一篇:

在线编制程序:https://mybinder.org/v2/gh/lotapp/BaseCode/master

在线预览:http://github.lesschina.com/python/base/oop/3.极度相关.html

代码裤子:https://github.com/lotapp/BaseCode/tree/master/python/2.OOP/4.Exception

 

1.异常

1.1 try…except

又到了开新课的时候了,小明同学这一次提前预习了知识,乘着老师还没来就在黑板上写下了这段Code:

In [1]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

division by zero

 

1.2 try…except…else…finally

小潘同学刚进入就映注重帘了,自语道:“try...except破获非常什么人不会?就能这么屁点东西万幸意思秀,切~
小编给你把 格式补全”

于是乎乘着小明上洗手间的时候,擦掉小明的Code,本身写了一段高大上的Code:

In [2]:

# 异常捕获全格式
def test(input_str):
    try:
        eval(input_str)
    except ZeroDivisionError as ex:
        print("except:", ex)
    else:
        print("else:没有异常就奖励100块~")
    finally:
        print("finally:小明是傻子~")


def main():
    test("1/0")
    print("-" * 10)
    test("print('小明啊小明你调坑里了~')")


if __name__ == '__main__':
    main()

 

except: division by zero
finally:小明是傻子~
----------
小明啊小明你调坑里了~
else:没有异常就奖励100块~
finally:小明是傻子~

 

那儿小明和先生共同进去了,同学们隐约间都听到小明的自夸声:“老师,笔者可好了,提前预习并且还写了个demo在黑板上呢~”

老师一进门看着黑板就笑了,同学们也笑成一片。小明心想,咦~难道自个儿写错了?定眼一看黑板,气呼呼的回座位了

else能够不写,可是大家
差没有多少如故会写的,终归能够领悟是的确没错误,而不是挡住了不当

1.3 四个特别管理

名师很安慰,感到那几个班真风趣,大家学习空前热情,为了照料小明,老师反问道:“有何人知道
八个要命怎么管理?”

小明神速的举手并把黑板上内容擦完,写下了如下代码:

In [3]:

# 多个异常捕获
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except NameError as ex:
        print(ex)
    except ZeroDivisionError as ex:
        print(ex)

if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

教授问了小美赞臣(Meadjohnson)声,有多少个出口?

小明骄傲的说道:“七个,笔者写了四个可怜管理,当然都实施了”

校友们又笑了,小潘作弄的说了句:“一看就清楚二〇一八年C#没好好学,那不都一致嘛,蒙受特别上边代码还执行吗?用心血好好思虑”

当大家感觉有些代码大概会出错开上下班时间,就足以用try来运维这段代码,如若实践出错,则持续代码不会继续实施,而是平昔跳转至except语句块,执行完except后,如果有finally语句块,则执行finally语句块

小明又狼狈了。。。

1.4 多分外简写

师资再度帮小明圆了个场:“已经很不轻巧了,便是终相当小得意的时候口误了,这小明同学你知道Python里面多极度有个方便人民群众写法吗?”

小明赶紧拿起粉笔刷刷刷的写完,然后说道:“of course

In [4]:

# 多个异常捕获的简写(注意哦,是元组哦)
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except (NameError, ZeroDivisionError) as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

教员赶紧夸了夸小明,心想,哎呦喂终于把那难缠的玩意弄回座位了。

小明走前还不忘说一句:“简写的时候注意格式哦,是 元组 不是逗号分隔”

教员这堂课很轻便,大家都预习了并且内容也相比简单。

进而以咨询的议程问道:“小潘同学,你精晓那么些的基类是怎么啊?如若要捕获全数非常该如何是好吗?”

小潘站起来讲道:“是BaseException

教员职员和工人扩充道:“全体的失实类型都一而再自BaseException,所以在采取except时须要小心的是,它不但捕获该项目标错误,还把其子类也一路抓获了”

就此一般在破获非凡的时候 把子类极度放在前方,父类放在前面

看如下代码:

In [5]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except BaseException as ex:
        print("base:", ex)
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

base: division by zero

 

假如把父类放第一个,那么ZeroDivisionError恒久也不会被实行了,其实您如若装了
代码规范提醒插件会提醒您的

能够参照笔者以前写的
vscode设置python3调度情形的扩展多数

来个通用非常捕获的简写(官方不引入应用简写):

In [6]:

# 直接except就行了
def main():
    try:
        1 / 0
        dnt += 1
    except:
        print("屏蔽错误")


if __name__ == '__main__':
    main()

 

屏蔽错误

 

先生继续讲到,大家来看三个光景,今后广大在线编辑器,你在他们那一个编辑框里写下了代码也会有丰盛抛出的,那是怎么处理的吧?

微软有开源代码编辑器比较受接待(VSCode的一有些):monaco-editor

唤醒一下,假诺实在要做在线编辑器,记得考虑一下fork炸弹,那么些实际上也是很老的事物了,程序猿基本上都应该接触过了

1.5 抛出十分

大家继续,像C#是用thorw抛出特别,那Python怎么 捕获异常后再抛出
呢?怎么自定义异常 呢?

继续往下看:

In [7]:

# 捕获异常后再丢出,eg:在线运行的用户Code
def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)  # 写个日志,回头出问题可以深究
        raise


if __name__ == '__main__':
    main()

 

division by zero

 

---------------------------------------------------------------------------
ZeroDivisionError                         Traceback (most recent call last)
<ipython-input-7-15f01346e2d8> in <module>()
      9 
     10 if __name__ == '__main__':
---> 11main()

<ipython-input-7-15f01346e2d8> in main()
      2 def main():
      3     try:
----> 41 / 0  # ZeroDivisionError: division by zero
      5     except ZeroDivisionError as ex:
      6         print(ex)  # 写个日志,回头出问题可以深究

ZeroDivisionError: division by zero

In [8]:

# 抛出自定义异常
class DntException(BaseException):
    pass


def get_age(num):
    if num <= 0:
        raise DntException("num must>0")
    else:
        print(num)


def main():
    get_age(-1)
    get_age(22)  # 程序崩了,这句话不会被执行了


if __name__ == '__main__':
    main()

 

---------------------------------------------------------------------------
DntException                              Traceback (most recent call last)
<ipython-input-8-7c9dec6ec225> in <module>()
     17 
     18 if __name__ == '__main__':
---> 19main()

<ipython-input-8-7c9dec6ec225> in main()
     12 
     13 def main():
---> 14get_age(-1)
     15     get_age(22)  # 程序崩了,这句话不会被执行了
     16 

<ipython-input-8-7c9dec6ec225> in get_age(num)
      6 def get_age(num):
      7     if num <= 0:
----> 8raise DntException("num must>0")
      9     else:
     10         print(num)

DntException: num must>0

 

非常这一块差不离讲完了(logging模块前边会说)有怎么着补充的能够说的^_^

 

1.6 C#异常

小明又进行了C#的代码转变,怎么看都认为照旧C#简易啊,根本无须说吗,代码一贴就秒懂了。。。

In [1]:

%%script csharp
try
{
    Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}

 

Input string was not in a correct format.

In [2]:

%%script csharp
//抛出自定义异常
try
{
    throw new Exception("出错了啊");
}
catch (Exception ex)
{
    Console.WriteLine(ex.Message);
}

 

出错了啊

 

你能够自定义相当类,承继Exception就可以,对了C#内部也可以有finally的

try
{
    throw new Exception("出错了啊");
    //Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}
finally
{
    Console.WriteLine("finally");
}

当今有的内需finally的地点好多都被using(){}接管了,所以一定情景会动用

先这么了

相关文章